#ifndef ACHIEVEMENTSPAGE_H
#define ACHIEVEMENTSPAGE_H

#include <QWidget>
#include <QPointer>
#include <QList>

class QString;
class QComboBox;
class QPushButton;
class QCheckBox;
class QScrollArea;
class QHBoxLayout;
class QVBoxLayout;
class Sim;

class AchievementsPage : public QWidget  {
  Q_OBJECT

  public:
    AchievementsPage ();

    QString getCSV (QList< QPointer<Sim> >);
    void readCSV (QList< QPointer<Sim> >, QString);
    void clear ();

  private slots:
    void addEntry (QString, Sim*, Sim*);
    void filterEntries ();
    void filterHolds ();
    void showAll ();

  private:
    QList< QPointer<Sim> > simFilterList;

    QComboBox *simFilterBox;
    QPushButton *filterButton;
    QPushButton *showAllButton;
    QCheckBox *showHoldsBox;
    QHBoxLayout *topLayout;

    QScrollArea *displayArea;
    QWidget *displayWidget;
    QVBoxLayout *displayLayout;

    QVBoxLayout *mainLayout;
};

#endif
