#ifndef ADDEDITSIMDIALOG_H
#define ADDEDITSIMDIALOG_H

#include <QDialog>

class QLineEdit;
class QSpinBox;
class QLabel;
class QComboBox;
class QCheckBox;
class QPushButton;
class QStringList;
class QHBoxLayout;
class QVBoxLayout;
class Sim;

class AddEditSimDialog : public QDialog  {
  Q_OBJECT

  public:
    AddEditSimDialog (int, QStringList);
    AddEditSimDialog (int, QStringList, Sim*);

  private slots:
    void ageChanged (int);
    void speciesChanged ();
    void semesterChanged (int);
    void witchChanged (bool);

  protected:
    QString ageFormat (int, int);

    QLineEdit *nameEdit;
    QComboBox *genderBox;
    QSpinBox *ageBox;
    QLabel *ageLabel;
    QCheckBox *deadBox;
    QComboBox *ghostColorBox;
    QComboBox *speciesBox;
    QComboBox *alignmentBox;
    QComboBox *householdBox;
    QComboBox *aspirationBox;
    QComboBox *secondaryAspirationBox;
    QSpinBox *semesterBox;
    QLineEdit *majorEdit;

    QCheckBox *alienBox;
    QCheckBox *zombieBox;
    QCheckBox *vampireBox;
    QCheckBox *werewolfBox;
    QCheckBox *servoBox;
    QCheckBox *plantsimBox;
    QCheckBox *bigfootBox;
    QCheckBox *witchBox;

    QPushButton *submitButton;

    QHBoxLayout *nameLayout;
    QHBoxLayout *ageLayout;
    QHBoxLayout *deathLayout;
    QHBoxLayout *speciesLayout;
    QHBoxLayout *householdLayout;
    QHBoxLayout *aspirationLayout;
    QHBoxLayout *collegeLayout;
    QVBoxLayout *paranormalColumnOne;
    QVBoxLayout *paranormalColumnTwo;
    QHBoxLayout *paranormalLayout;
    QVBoxLayout *mainLayout;

  private:
    int epFlags;
};

#endif
