#include <QTextEdit>
#include <QPushButton>
#include <QVBoxLayout>

#include "addnotesdialog.h"

AddNotesDialog::AddNotesDialog (QString text, int simIndex)  {
  simNum = simIndex;

  display = new QTextEdit ();
  display->setText (text);
  saveButton = new QPushButton ("Save Notes");
  saveButton->setMaximumSize (saveButton->sizeHint ());

  mainLayout = new QVBoxLayout ();
  mainLayout->addWidget (display);
  mainLayout->addWidget (saveButton);
  mainLayout->setAlignment (saveButton, Qt::AlignCenter);

  setLayout (mainLayout);

  connect (saveButton, SIGNAL (clicked ()), this, SLOT (prepareNotes ()));
}

void AddNotesDialog::prepareNotes ()  {
  emit saveNotes (display->toPlainText (), simNum);

  close ();
}
