#include <QLineEdit>
#include <QSpinBox>
#include <QLabel>
#include <QComboBox>
#include <QCheckBox>
#include <QPushButton>
#include <QHBoxLayout>
#include <QVBoxLayout>

#include "const.h"
#include "addsimdialog.h"

AddSimDialog::AddSimDialog (int epFlags, QStringList houses)
  : AddEditSimDialog (epFlags, houses)
{
  submitButton->setText ("Add Sim");
  connect (submitButton, SIGNAL (clicked ()), this, SLOT (addSim ())); 
}

void AddSimDialog::addSim ()  {
  QString name = nameEdit->text ();
  int gender = genderBox->currentIndex () + 1;
  int age = ageBox->value ();
  bool alive = !deadBox->isChecked ();
  int ghostColor = ghostColorBox->currentIndex ();
  int aspiration = aspirationBox->currentIndex ();
  int secondaryAspiration = secondaryAspirationBox->currentIndex ();
  QString household = householdBox->currentText ();

  int paraFlags = 0;
  if (alienBox->isChecked ()) paraFlags += ALIEN;
  if (zombieBox->isChecked ()) paraFlags += ZOMBIE;
  if (vampireBox->isChecked ()) paraFlags += VAMPIRE;
  if (werewolfBox->isChecked ()) paraFlags += WEREWOLF;
  if (servoBox->isChecked ()) paraFlags += SERVO;
  if (plantsimBox->isChecked ()) paraFlags += PLANTSIM;
  if (bigfootBox->isChecked ()) paraFlags += BIGFOOT;
  if (speciesBox->currentIndex () == 1) paraFlags += LARGE_DOG;
  if (speciesBox->currentIndex () == 2) paraFlags += SMALL_DOG;
  if (speciesBox->currentIndex () == 3) paraFlags += CAT;
  if (witchBox->isChecked ()) paraFlags += WITCH;

  int semesters = semesterBox->value ();
  QString major = majorEdit->text ();

  int alignment = alignmentBox->currentIndex () - 3;

  emit newSim (name, gender, age, aspiration, secondaryAspiration, alive, 
               ghostColor, household, paraFlags, alignment, semesters, major);
  close ();
  clear ();
}

void AddSimDialog::clear ()  {
  nameEdit->clear ();
  genderBox->setCurrentIndex (0);
  ageBox->setValue (ADULT);
  deadBox->setChecked (false);
  ghostColorBox->setCurrentIndex (0);
  speciesBox->setCurrentIndex (0);
  alignmentBox->setCurrentIndex (3);
  alignmentBox->setEnabled (false);
  householdBox->setCurrentIndex (0);
  aspirationBox->setCurrentIndex (0);
  secondaryAspirationBox->setCurrentIndex (0);
  semesterBox->setValue (0);
  majorEdit->clear ();
  alienBox->setChecked (false);
  zombieBox->setChecked (false);
  vampireBox->setChecked (false);
  werewolfBox->setChecked (false);
  servoBox->setChecked (false);
  plantsimBox->setChecked (false);
  bigfootBox->setChecked (false);
  witchBox->setChecked (false);
}
