#ifndef AGEPAGE_H
#define AGEPAGE_H

#include <QWidget>
#include <QLinkedList>
#include <QPointer>

class QString;
class QTreeView;
class QPushButton;
class QLabel;
class QCheckBox;
class QAbstractItemModel;
class QStandardItemModel;
class QSortFilterProxyModel;
class SimProxyModel;
class FilterDialog;
class QModelIndex;
class QVBoxLayout;
class QHBoxLayout;
class QMainWindow;
class Sim;

class AgePage : public QWidget {
  Q_OBJECT

  public:
    AgePage (QMainWindow*);

    void setSourceModel (QAbstractItemModel*);
    QAbstractItemModel *sourceModel ();

    void setNotesDisplay (QString);
    void setImageFile (QString);
    void sort ();

  signals:
    void newListManagementDialog ();
    void newAddSimDialog ();
    void newEditSimDialog (int);
    void newFilterDialog ();
    void newSettingsDialog ();
    void newAddNotesDialog (int);
    void assignImageFile (int, QString);

    void update (int);

  public slots:
    void reset ();

  private slots:
    void sendUpdate ();
    void launchAddNotesDialog ();
    void launchEditSimDialog ();
//    void createFilterDialog ();
    void getImageFile ();

  private:
    FilterDialog *filterDialog;

    QPushButton *listManagementButton;
    QPushButton *addNewButton;
    QPushButton *editButton;
    QPushButton *filterButton;
    QPushButton *settingsButton;
    QTreeView *simView;
    QLabel *notesDisplay;
    QPushButton *addNotesButton;
    QLabel *imageDisplay;
    QPushButton *addImageButton;

    QHBoxLayout *topLayout;
    QVBoxLayout *mainLayout;

    QStandardItemModel *simModel;
    SimProxyModel *proxyModel;

    int currentNotes;
    QList<QString> notes;
};

#endif
