#ifndef ASPIRATIONPAGE_H
#define ASPIRATIONPAGE_H

#include <QWidget>
#include <QPointer>
#include <QList>

class Sim;
class AspirationDisplay;
class QString;
class QVBoxLayout;
class QHBoxLayout;
class QLabel;
class QComboBox;
class QGroupBox;
class QScrollArea;

class AspirationPage : public QWidget  {
  Q_OBJECT

  public:
    AspirationPage (int);

    void setSim (QPointer<Sim>);
    void setEPFlags (int);

  private slots:
    void updateDisplay ();

    void updateAspiration (AspirationDisplay*, int, int);
    void updateLTW (AspirationDisplay*, int, QString, int, int);

    void deleteAspirationDisplay (AspirationDisplay*);

  private:
    QPointer<Sim> sim;
    int epFlags;

    QList<AspirationDisplay*> displayList;
    QLabel *nameLabel;
    QLabel *hobbyLabel;
    QComboBox *hobbyBox;
    QWidget *displayWidget;
    QScrollArea *displayArea;

    QVBoxLayout *displayLayout;
    QHBoxLayout *nameLayout;
    QHBoxLayout *hobbyLayout;
    QVBoxLayout *mainLayout;
};

#endif
