#ifndef CONST_H
#define CONST_H

// File formats
const int V0_1 = 0;
const int V0_2 = 1;
const int V0_3 = 2;
const int V0_4 = 3;
const int V0_5 = 4;

// Sim types
const int PLAYABLE = 0;
const int TOWNIE = 1;
const int NPC = 2;

// Expansion Packs
const int UNIVERSITY = 1;
const int NIGHTLIFE = 2;
const int OFB = 4;
const int PETS = 8;
const int SEASONS = 16;
const int BONVOYAGE = 32;
const int FREETIME = 64;
const int APARTMENTLIFE = 128;

// Age Transitions
const int BABY = 0;
const int TODDLER = 3;
const int CHILD = 7;
const int TEEN = 15;
const int YOUNG_ADULT = -1;
const int ADULT = 30;
const int ELDER = 59;

// Plantsim Age Transitions
const int PLANTSIM_TODDLER = 0;
const int PLANTSIM_ADULT = 4;
const int PLANTSIM_ELDER = 33;

// Pet Age Transitions
const int PUPPY = 0;
const int KITTEN = 0;
const int ADULT_DOG = 4;
const int ADULT_CAT = 5;
const int ELDER_LARGE_DOG = 26;
const int ELDER_SMALL_DOG = 30;
const int ELDER_CAT = 31;

// Ghost Colors
const int PINK = 0;
const int GREEN = 1;
const int YELLOW = 2;
const int BLUE = 3;
const int ORANGE = 4;
const int PURPLE = 5;
const int RED = 6;
const int WHITE = 7;
//const int TRANSPARENT = 8;
const int BRIGHT_GREEN = 9;

// Genders
const int UNKNOWN = 0;
const int MALE = 1;
const int FEMALE = 2;

// Aspirations
const int UNAVAILABLE = -1;
const int NONE = 0;
const int FORTUNE = 1;
const int FAMILY = 2;
const int ROMANCE = 3;
const int POPULARITY = 4;
const int KNOWLEDGE = 5;
const int PLEASURE = 6;
const int GRILLED_CHEESE = 7;
const int GROW_UP = 8;

// Hobbies
const int ARTS_CRAFTS = 1;
const int CUISINE = 2;
const int FILM_LITERATURE = 3;
const int FITNESS = 4;
const int GAMING = 5;
const int MUSIC_DANCE = 6;
const int NATURE = 7;
const int SCIENCE = 8;
const int SPORTS = 9;
const int TINKERING = 10;

// Paranormal Flags
const int HUMAN = 0;
const int ALIEN = 1;
const int ZOMBIE = 2;
const int VAMPIRE = 4;
const int SERVO = 8;
const int WEREWOLF = 16;
const int PLANTSIM = 32;
const int BIGFOOT = 64;
const int SMALL_DOG = 128;
const int LARGE_DOG = 256;
const int CAT = 512;
const int WITCH = 1024;

// Witch Alignments
const int ATROCIOUSLYEVIL = -3;
const int EVIL = -2;
const int MEAN = -1;
const int NEUTRAL = 0;
const int NICE = 1;
const int GOOD = 2;
const int INFALLIBLYGOOD = 3;

// Filter Flags
const int ALIVE_FILTER = 1;
const int DEAD_FILTER = 2;

const int PLAYABLE_FILTER = 1;
const int TOWNIE_FILTER = 2;
const int NPC_FILTER = 4;
const int RUNAWAY_FILTER = 8;
const int ADOPTION_FILTER = 16;
const int DOWNTOWNIE_FILTER = 32;
const int GARDEN_CLUB_FILTER = 64;
const int ISLAND_FILTER = 128;
const int MOUNTAIN_FILTER = 256;
const int ASIAN_FILTER = 512;
const int TOURIST_FILTER = 1024;
const int HOBBY_FILTER = 2048;
const int SOCIALITE_FILTER = 4096;
const int BOHEMIAN_FILTER = 8192;
const int JOCK_FILTER = 16384;
const int TECHIE_FILTER = 32768;
const int GEARHEAD_FILTER = 65536;

const int HUMAN_FILTER = 1;
const int LARGE_DOG_FILTER = 2;
const int SMALL_DOG_FILTER = 4;
const int CAT_FILTER = 8;

const int MALE_FILTER = 1;
const int FEMALE_FILTER = 2;

const int BABY_FILTER = 1;
const int TODDLER_FILTER = 2;
const int CHILD_FILTER = 4;
const int TEEN_FILTER = 8;
const int YA_FILTER = 16;
const int ADULT_FILTER = 32;
const int ELDER_FILTER = 64;

const int NONE_FILTER = 1;
const int GROW_UP_FILTER = 2;
const int FORTUNE_FILTER = 4;
const int FAMILY_FILTER = 8;
const int POPULARITY_FILTER = 16;
const int ROMANCE_FILTER = 32;
const int KNOWLEDGE_FILTER = 64;
const int PLEASURE_FILTER = 128;
const int GRILLED_CHEESE_FILTER = 256;

const int NORMAL_FILTER = 1;
const int ALIEN_FILTER = 2;
const int ZOMBIE_FILTER = 4;
const int VAMPIRE_FILTER = 8;
const int WEREWOLF_FILTER = 16;
const int SERVO_FILTER = 32;
const int PLANTSIM_FILTER = 64;
const int BIGFOOT_FILTER = 128;
const int WITCH_FILTER = 256;

#endif
