#include <QString>
#include <QLineEdit>
#include <QPushButton>
#include <QVBoxLayout>

#include "edithouseholddialog.h"

EditHouseholdDialog::EditHouseholdDialog (QString n)  {
  name = n;

  nameEdit = new QLineEdit (name);
  nameEdit->selectAll ();
  okButton = new QPushButton ("Ok");
  okButton->setMaximumSize (okButton->sizeHint ());
  mainLayout = new QVBoxLayout ();
  mainLayout->addWidget (nameEdit);
  mainLayout->addWidget (okButton);
  mainLayout->setAlignment (okButton, Qt::AlignCenter);

  connect (okButton, SIGNAL (clicked ()), this, SLOT (setNameReplacement ()));

  setLayout (mainLayout);
}

void EditHouseholdDialog::changeName (QString n)  {
  name = n;
  nameEdit->setText (name);
  nameEdit->selectAll ();
}

void EditHouseholdDialog::setNameReplacement ()  {
  emit replaceName (name, nameEdit->text ());
  hide ();
}
