#include <QLineEdit>
#include <QSpinBox>
#include <QLabel>
#include <QComboBox>
#include <QCheckBox>
#include <QPushButton>
#include <QHBoxLayout>
#include <QVBoxLayout>

#include "const.h"
#include "editsimdialog.h"
#include "sim.h"

EditSimDialog::EditSimDialog (int epFlags, QStringList houses, Sim *s)
  : AddEditSimDialog (epFlags, houses, s)
{
  sim = s;

  submitButton->setText ("Edit Sim");
  connect (submitButton, SIGNAL (clicked ()), this, SLOT (editSim ()));
}

void EditSimDialog::editSim ()  {
  sim->name = nameEdit->text ();
  sim->gender = genderBox->currentIndex () + 1;
  sim->age = ageBox->value ();
  sim->alive = !deadBox->isChecked ();
  sim->ghostColor = ghostColorBox->currentIndex ();

  switch (speciesBox->currentIndex ())  {
    case 0: sim->species = HUMAN; break;
    case 1: sim->species = LARGE_DOG; break;
    case 2: sim->species = SMALL_DOG; break;
    case 3: sim->species = CAT; break;
    default: break;
  }

  sim->alignment = alignmentBox->currentIndex () - 3;

  sim->household = householdBox->currentText ();
  sim->updateAspiration (aspirationBox->currentIndex (),
                         secondaryAspirationBox->currentIndex ());
  sim->youngAdult = semesterBox->value () > 0;
  sim->semester = semesterBox->value ();
  sim->major = majorEdit->text ();

  sim->alien = alienBox->isChecked ();
  sim->zombie = zombieBox->isChecked ();
  sim->vampire = vampireBox->isChecked ();
  sim->servo = servoBox->isChecked ();
  sim->werewolf = werewolfBox->isChecked ();
  sim->plantsim = plantsimBox->isChecked ();
  sim->bigfoot = bigfootBox->isChecked ();
  sim->witch = witchBox->isChecked ();

  emit simEdited ();
  close ();
}
