#ifndef FAMILYBROWSER_H
#define FAMILYBROWSER_H

#include <QDialog>
#include <QPointer>
#include <QList>

class Sim;
class QLabel;
class QPushButton;
class QComboBox;
class QHBoxLayout;
class QVBoxLayout;
class QGroupBox;

class FamilyBrowser : public QDialog  {
  Q_OBJECT

  public:
    FamilyBrowser (QPointer<Sim>, QList< QPointer<Sim> >);

    void setSim (QPointer<Sim>);
    void setSimList (QList< QPointer<Sim> >);

  signals:
    void closeAndUpdate ();

  private slots:
    void viewSpouse ();
    void viewParent1 ();
    void viewParent2 ();
    void viewChild ();
    void viewSibling ();

    void setSpouse ();
    void setParent1 ();
    void setParent2 ();
    void addChild ();
    void removeChild ();
    void addSibling ();

  private:
    void sortList (QList< QPointer<Sim> >&);
    void updateDisplay ();

    QPointer<Sim> sim;
    QList< QPointer<Sim> > simList;

    QLabel *nameLabel;

    QPushButton *spouseButton;
    QLabel *noSpouseLabel;
    QPushButton *setSpouseButton;
    QComboBox *setSpouseBox;

    QPushButton *parent1Button;
    QPushButton *parent2Button;
    QLabel *noParent1Label;
    QLabel *noParent2Label;
    QPushButton *setParent1Button;
    QPushButton *setParent2Button;
    QComboBox *setParent1Box;
    QComboBox *setParent2Box;

    QPushButton *childButton;
    QComboBox *childrenBox;
    QLabel *noChildrenLabel;
    QPushButton *addChildButton;
    QComboBox *addChildBox;
    QPushButton *removeChildButton;
    QComboBox *removeChildBox;

    QPushButton *siblingButton;
    QComboBox *siblingBox;
    QLabel *noSiblingsLabel;
    QPushButton *addSiblingButton;
    QComboBox *addSiblingBox;

    QPushButton *closeButton;

    QHBoxLayout *spouseLayout;
    QHBoxLayout *addSpouseLayout;
    QHBoxLayout *parent1Layout;
    QHBoxLayout *addParent1Layout;
    QHBoxLayout *parent2Layout;
    QHBoxLayout *addParent2Layout;
    QHBoxLayout *childrenLayout;
    QHBoxLayout *addChildLayout;
    QHBoxLayout *removeChildLayout;
    QHBoxLayout *siblingLayout;
    QHBoxLayout *addSiblingLayout;

    QVBoxLayout *navigationLayout;
    QVBoxLayout *editingLayout;

    QGroupBox *navigationGroupBox;
    QGroupBox *editingGroupBox;

    QHBoxLayout *boxLayout;
    QVBoxLayout *mainLayout;
};

#endif
