#ifndef FAMILYPAGE_H
#define FAMILYPAGE_H

#include <QWidget>
#include <QPointer>
#include <QList>

class Sim;
class FamilyBrowser;
class QLabel;
class QPushButton;
class QCheckBox;
class QTreeView;
class QHBoxLayout;
class QVBoxLayout;
class QAbstractItemModel;
class QStandardItemModel;
class FamilyProxyModel;

class FamilyPage : public QWidget  {
  Q_OBJECT

  public:
    FamilyPage (QList< QPointer<Sim> >);

    void setSim (QPointer<Sim>);
    void setSimList (QList< QPointer<Sim> >);
    void setSourceModel (QAbstractItemModel*);

  private slots:
    void createFamilyBrowser ();
    void showFamily ();

  private:
    void addSim (QPointer<Sim>, QString);
    void addRecursively (QPointer<Sim>, QString, QString, QString);
    void addCousinsRecursively (QPointer<Sim>, QString, int);
    void addSeriesRecursively (QPointer<Sim>, QString, QString, QString, 
                               QString, int, QPointer<Sim>);
    void countDownCousinsRecursively (QPointer<Sim>, int, int);
    QString ntimes (int);
    QString nth (int);

    QPointer<Sim> sim;
    QList< QPointer<Sim> > simList;
    QList< QPointer<Sim> > displayedSimsList;

    FamilyBrowser *familyBrowser;

    QPushButton *addEditFamilyButton;
    QPushButton *kintermsButton;
    QCheckBox *livingSimsBox;
    QCheckBox *playableSimsBox;
    QLabel *nameLabel;
    QTreeView *familyView;

    QHBoxLayout *buttonLayout;
    QVBoxLayout *mainLayout;

    QStandardItemModel *familyModel;
    FamilyProxyModel *proxyModel;
};

#endif
