#include <QAbstractItemModel>
#include <QString>

#include "familyproxymodel.h"

FamilyProxyModel::FamilyProxyModel (QObject *parent)
  : QSortFilterProxyModel (parent)
{}

void FamilyProxyModel::setSourceModel (QAbstractItemModel *model)  {
  this->QSortFilterProxyModel::setSourceModel (model);
}

bool FamilyProxyModel::lessThan (const QModelIndex &one, 
                                 const QModelIndex &two) const  {
  QString oneData = one.data ().toString ();
  QString twoData = two.data ().toString ();

  if (one.column () == 0)
    return oneData < twoData;

  if (oneData.contains ("Husband") || oneData.contains ("Wife")) return true;
  if (twoData.contains ("Husband") || twoData.contains ("Wife")) return false;
  if (oneData.contains ("Son") || oneData.contains ("Daughter")) return true;
  if (twoData.contains ("Son") || twoData.contains ("Daughter")) return false;

  if (oneData.contains ("son") || oneData.contains ("daughter"))  {
    if (twoData.contains ("son") || twoData.contains ("daughter"))
      return oneData.size () < twoData.size ();
    else return true;
  }

  if (twoData.contains ("son") || twoData.contains ("daughter")) return false;
  if (oneData.contains ("Brother") || oneData.contains ("Sister")) return true;
  if (twoData.contains ("Brother") || twoData.contains ("Sister")) return false;
  if (oneData.contains ("Nephew") || oneData.contains ("Niece")) return true;
  if (twoData.contains ("Nephew") || twoData.contains ("Niece")) return false;

  if (oneData.contains ("nephew") || oneData.contains ("niece"))  {
    if (twoData.contains ("nephew") || twoData.contains ("niece"))
      return oneData.size () < twoData.size ();
    else return true;
  }

  if (twoData.contains ("nephew") || twoData.contains ("niece")) return false;
  if (oneData.contains ("Father") || oneData.contains ("Mother")) return true;
  if (twoData.contains ("Father") || twoData.contains ("Mother")) return false;

  if (oneData.contains ("father") || oneData.contains ("mother"))  {
    if (twoData.contains ("father") || twoData.contains ("mother"))
      return oneData.size () < twoData.size ();
    else return true;
  }

  if (twoData.contains ("father") || twoData.contains ("mother")) return false;
  if ((oneData.contains ("Uncle") && !oneData.contains ("Great-Uncle")) ||
      (oneData.contains ("Aunt") && !oneData.contains ("Great-Aunt")))
    return true;
  if ((twoData.contains ("Uncle") && !twoData.contains ("Great-Uncle")) ||
      (twoData.contains ("Aunt") && !twoData.contains ("Great-Aunt")))
    return false;

  if (oneData.contains ("Great-Uncle") || oneData.contains ("Great-Aunt"))  {
    if (twoData.contains ("Great-Uncle") || twoData.contains ("Great-Aunt"))
      return oneData.size () < twoData.size ();
    else return true;
  }

  if (twoData.contains ("Great-Uncle") || twoData.contains ("Great-Aunt")) 
    return false;

  if (oneData.contains ("First") && !(twoData.contains ("First"))) 
    return true;
  if (twoData.contains ("First") && !(oneData.contains ("First"))) 
    return false;

  if (oneData.contains ("Second") && !(twoData.contains ("Second"))) 
    return true;
  if (twoData.contains ("Second") && !(oneData.contains ("Second")))
    return false;

  if (oneData.contains ("Third") && !(twoData.contains ("Third"))) 
    return true;
  if (twoData.contains ("Third") && !(oneData.contains ("Third"))) 
    return false;

  if (oneData.contains ("Fourth") && !(twoData.contains ("Fourth"))) 
    return true;
  if (twoData.contains ("Fourth") && !(oneData.contains ("Fourth"))) 
    return false;

  if (oneData.contains ("Fifth") && !(twoData.contains ("Fifth"))) 
    return true;
  if (twoData.contains ("Fifth") && !(oneData.contains ("Fifth"))) 
    return false;

  if (oneData.contains ("Sixth") && !(twoData.contains ("Sixth"))) 
    return true;
  if (twoData.contains ("Sixth") && !(oneData.contains ("Sixth"))) 
    return false;

  if (oneData.contains ("Seventh") && !(twoData.contains ("Seventh"))) 
    return true;
  if (twoData.contains ("Seventh") && !(oneData.contains ("Seventh"))) 
    return false;

  if (oneData.contains ("Eighth") && !(twoData.contains ("Eighth"))) 
    return true;
  if (twoData.contains ("Eighth") && !(oneData.contains ("Eighth"))) 
    return false;

  if (oneData.contains ("Ninth") && !(twoData.contains ("Ninth"))) 
    return true;
  if (twoData.contains ("Ninth") && !(oneData.contains ("Ninth"))) 
    return false;

  if (oneData.contains ("Tenth") && !(twoData.contains ("Tenth"))) 
    return true;
  if (twoData.contains ("Tenth") && !(oneData.contains ("Tenth"))) 
    return false;

  if (oneData.contains ("Eleventh") && !(twoData.contains ("Eleventh"))) 
    return true;
  if (twoData.contains ("Eleventh") && !(oneData.contains ("Eleventh"))) 
    return false;

  if (oneData.contains ("Twelfth") && !(twoData.contains ("Twelfth"))) 
    return true;
  if (twoData.contains ("Twelfth") && !(oneData.contains ("Twelfth"))) 
    return false;

  if (oneData.contains ("Thirteenth") && !(twoData.contains ("Thirteenth"))) 
    return true;
  if (twoData.contains ("Thirteenth") && !(oneData.contains ("Thirteenth"))) 
    return false;

  if (oneData.contains ("Fourteenth") && !(twoData.contains ("Fourteenth"))) 
    return true;
  if (twoData.contains ("Fourteenth") && !(oneData.contains ("Fourteenth"))) 
    return false;

  if (oneData.contains ("Fifteenth") && !(twoData.contains ("Fifteenth"))) 
    return true;
  if (twoData.contains ("Fifteenth") && !(oneData.contains ("Fifteenth"))) 
    return false;

  if (oneData.contains ("Sixteenth") && !(twoData.contains ("Sixteenth"))) 
    return true;
  if (twoData.contains ("Sixteenth") && !(oneData.contains ("Sixteenth"))) 
    return false;

  if (oneData.contains ("Seventeenth") && !(twoData.contains ("Seventeenth"))) 
    return true;
  if (twoData.contains ("Seventeenth") && !(oneData.contains ("Seventeenth"))) 
    return false;

  if (oneData.contains ("Eighteenth") && !(twoData.contains ("Eighteenth"))) 
    return true;
  if (twoData.contains ("Eighteenth") && !(oneData.contains ("Eighteenth"))) 
    return false;

  if (oneData.contains ("Nineteenth") && !(twoData.contains ("Nineteenth"))) 
    return true;
  if (twoData.contains ("Nineteenth") && !(oneData.contains ("Nineteenth"))) 
    return false;

  if (oneData.contains ("Twentieth") && !(twoData.contains ("Twentieth"))) 
    return true;
  if (twoData.contains ("Twentieth") && !(oneData.contains ("Twentieth"))) 
    return false;

  if (twoData.contains ("Removed") && !(oneData.contains ("Removed"))) 
    return true;
  if (oneData.contains ("Removed") && !(twoData.contains ("Removed"))) 
    return false;

  if (!(oneData.contains ("Removed")) && !(twoData.contains ("Removed"))) 
    return true;

  if (oneData.contains ("Once")) return true;
  if (twoData.contains ("Once")) return false;
  if (oneData.contains ("Twice")) return true;
  if (twoData.contains ("Twice")) return false;
  if (oneData.contains ("Three")) return true;
  if (twoData.contains ("Three")) return false;
  if (oneData.contains ("Four")) return true;
  if (twoData.contains ("Four")) return false;
  if (oneData.contains ("Five")) return true;
  if (twoData.contains ("Five")) return false;
  if (oneData.contains ("Six")) return true;
  if (twoData.contains ("Six")) return false;
  if (oneData.contains ("Seven")) return true;
  if (twoData.contains ("Seven")) return false;
  if (oneData.contains ("Eight")) return true;
  if (twoData.contains ("Eight")) return false;
  if (oneData.contains ("Nine")) return true;
  if (twoData.contains ("Nine")) return false;
  if (oneData.contains ("Ten")) return true;
  if (twoData.contains ("Ten")) return false;
  if (oneData.contains ("Eleven")) return true;
  if (twoData.contains ("Eleven")) return false;
  if (oneData.contains ("Twelve")) return true;
  if (twoData.contains ("Twelve")) return false;
  if (oneData.contains ("Thirteen")) return true;
  if (twoData.contains ("Thirteen")) return false;
  if (oneData.contains ("Fourteen")) return true;
  if (twoData.contains ("Fourteen")) return false;
  if (oneData.contains ("Fifteen")) return true;
  if (twoData.contains ("Fifteen")) return false;
  if (oneData.contains ("Sixteen")) return true;
  if (twoData.contains ("Sixteen")) return false;
  if (oneData.contains ("Seventeen")) return true;
  if (twoData.contains ("Seventeen")) return false;
  if (oneData.contains ("Eighteen")) return true;
  if (twoData.contains ("Eighteen")) return false;
  if (oneData.contains ("Nineteen")) return true;
  if (twoData.contains ("Nineteen")) return false;
  if (oneData.contains ("Twenty")) return true;
  if (twoData.contains ("Twenty")) return false;

  return oneData < twoData;
}
