#ifndef FILTERDIALOG_H
#define FILTERDIALOG_H

#include <QDialog>

class QCheckBox;
class QGroupBox;
class QHBoxLayout;
class QVBoxLayout;
class QGridLayout;
class SimProxyModel;

class FilterDialog : public QDialog  {
  Q_OBJECT

  public:
    FilterDialog ();

  signals:
    void setAliveFilter (bool);
    void setDeadFilter (bool);

    void setPlayableFilter (bool);
    void setTownieFilter (bool);
    void setNPCFilter (bool);
    void setRunawayFilter (bool);
    void setAdoptionFilter (bool);
    void setDowntownieFilter (bool);
    void setGardenClubFilter (bool);
    void setIslandFilter (bool);
    void setMountainFilter (bool);
    void setAsianFilter (bool);
    void setTouristFilter (bool);
    void setHobbyFilter (bool);
    void setSocialiteFilter (bool);
    void setBohemianFilter (bool);
    void setJockFilter (bool);
    void setTechieFilter (bool);
    void setGearheadFilter (bool);

    void setHumanFilter (bool);
    void setLargeDogFilter (bool);
    void setSmallDogFilter (bool);
    void setCatFilter (bool);

    void setMaleFilter (bool);
    void setFemaleFilter (bool);

    void setBabyFilter (bool);
    void setToddlerFilter (bool);
    void setChildFilter (bool);
    void setTeenFilter (bool);
    void setYAFilter (bool);
    void setAdultFilter (bool);
    void setElderFilter (bool);

    void setNoneFilter (bool);
    void setGrowUpFilter (bool);
    void setFortuneFilter (bool);
    void setFamilyFilter (bool);
    void setPopularityFilter (bool);
    void setRomanceFilter (bool);
    void setKnowledgeFilter (bool);
    void setPleasureFilter (bool);
    void setGrilledCheeseFilter (bool);

    void setNormalFilter (bool);
    void setAlienFilter (bool);
    void setZombieFilter (bool);
    void setVampireFilter (bool);
    void setWerewolfFilter (bool);
    void setServoFilter (bool);
    void setPlantsimFilter (bool);
    void setBigfootFilter (bool);
    void setWitchFilter (bool);

  private:
    QCheckBox *aliveBox;
    QCheckBox *deadBox;

    QCheckBox *playableBox;
    QCheckBox *townieBox;
    QCheckBox *npcBox;
    QCheckBox *runawayBox;
    QCheckBox *adoptionBox;
    QCheckBox *downtownieBox;
    QCheckBox *gardenClubBox;
    QCheckBox *islandBox;
    QCheckBox *mountainBox;
    QCheckBox *asianBox;
    QCheckBox *touristBox;
    QCheckBox *hobbyBox;
    QCheckBox *socialiteBox;
    QCheckBox *bohemianBox;
    QCheckBox *jockBox;
    QCheckBox *techieBox;
    QCheckBox *gearheadBox;

    QCheckBox *humanBox;
    QCheckBox *largeDogBox;
    QCheckBox *smallDogBox;
    QCheckBox *catBox;

    QCheckBox *maleBox;
    QCheckBox *femaleBox;

    QCheckBox *babyBox;
    QCheckBox *toddlerBox;
    QCheckBox *childBox;
    QCheckBox *teenBox;
    QCheckBox *yaBox;
    QCheckBox *adultBox;
    QCheckBox *elderBox;

    QCheckBox *noneBox;
    QCheckBox *growUpBox;
    QCheckBox *fortuneBox;
    QCheckBox *familyBox;
    QCheckBox *popularityBox;
    QCheckBox *romanceBox;
    QCheckBox *knowledgeBox;
    QCheckBox *pleasureBox;
    QCheckBox *grilledCheeseBox;

    QCheckBox *normalBox;
    QCheckBox *alienBox;
    QCheckBox *zombieBox;
    QCheckBox *vampireBox;
    QCheckBox *werewolfBox;
    QCheckBox *servoBox;
    QCheckBox *plantsimBox;
    QCheckBox *bigfootBox;
    QCheckBox *witchBox;

    QGroupBox *livingGroup;
    QGroupBox *typeGroup;
    QGroupBox *speciesGroup;
    QGroupBox *genderGroup;
    QGroupBox *ageGroup;
    QGroupBox *aspirationGroup;
    QGroupBox *paranormalGroup;

    QHBoxLayout *livingLayout;
    QGridLayout *typeLayout;
    QGridLayout *speciesLayout;
    QHBoxLayout *genderLayout;
    QGridLayout *ageLayout;
    QGridLayout *aspirationLayout;
    QGridLayout *paranormalLayout;
    QVBoxLayout *mainLayout;
};

#endif
