#ifndef HOUSEHOLDPAGE_H
#define HOUSEHOLDPAGE_H

#include <QWidget>

class QAbstractItemModel;
class QStandardItemModel;
class QString;
class QStringList;
class QVBoxLayout;
class QHBoxLayout;
class QSortFilterProxyModel;
class QTreeView;
class QLabel;
class QPushButton;
class QScrollArea;
class QCheckBox;
class EditHouseholdDialog;

class HouseholdPage : public QWidget {
  Q_OBJECT

  public:
    HouseholdPage ();

    void setSourceModel (QAbstractItemModel*);
    void displayNames (QStringList);
    void setNotPlayed ();
    void reset ();

    QString getCSV ();
    void readCSV (QString);

    QAbstractItemModel *sourceModel ();

  private slots:
    void updateDisplay ();
    void updateAlreadyPlayed (int);
    void createEditHouseholdDialog ();

  signals:
    void showHousehold (QString);
    void replaceHouseholdName (QString, QString);

  private:
    EditHouseholdDialog *editHouseholdDialog;

    QTreeView *householdView;
    QPushButton *editNameButton;
    QCheckBox *alreadyPlayedBox;
    QScrollArea *displayArea;
    QLabel *displayLabel;

    QHBoxLayout *topLayout;
    QVBoxLayout *mainLayout;

    QStandardItemModel *householdModel;
    QSortFilterProxyModel *proxyModel;
};

#endif
