#ifndef IMPORTDISPLAY_H
#define IMPORTDISPLAY_H

#include <QWidget>

class QCheckBox;
class QComboBox;
class QString;
class QLineEdit;
class QHBoxLayout;
class QVBoxLayout;

class ImportSimDisplay : public QWidget  {
  public:
    ImportSimDisplay ();

    void setName (QString);
    void setHousehold (QString);
    void setGender (QString);
    void setLifeStage (QString);
    void setAspiration (QString, QString);
    void setSpecies (QString);
    void setEPFlags (int);

    void setChecked (bool);
    void setParaFlags (int);
    void setAlignment (int);

    bool isChecked ();
    int getParaFlags ();
    QString getHouseholdName ();
    int getAlignment ();

  private:
    void updateDisplay ();

    QString name;
    QString gender;
    QString age;
    QString species;
    QString aspiration;
    QString saspiration;
    int epFlags;

    QCheckBox *simBox;

    QCheckBox *alienBox;
    QCheckBox *zombieBox;
    QCheckBox *vampireBox;
    QCheckBox *servoBox;
    QCheckBox *werewolfBox;
    QCheckBox *plantsimBox;
    QCheckBox *bigfootBox;
    QCheckBox *witchBox;

    QComboBox *alignmentBox;
    QLineEdit *householdEdit;

    QHBoxLayout *topLayout;
    QHBoxLayout *paraLayout;
    QVBoxLayout *mainLayout;
};

#endif
