#include <QStandardItemModel>
#include <QTextStream>
#include <QApplication>
#include <QMessageBox>

#include <iostream>
#include <cstdlib>
#include <ctime>
using namespace std;

#include "mainwindow.h"

QStandardItemModel *createSimModel (QObject *parent)  {
  QStandardItemModel *simModel = new QStandardItemModel (0, 5, parent);

  simModel->setHeaderData (0, Qt::Horizontal, "Sim");
  simModel->setHeaderData (1, Qt::Horizontal, "Household");
  simModel->setHeaderData (2, Qt::Horizontal, "Age");
  simModel->setHeaderData (3, Qt::Horizontal, "Life Stage");
  simModel->setHeaderData (4, Qt::Horizontal, "Aspiration");

  return simModel;
}

QStandardItemModel *createHouseholdModel (QObject *parent)  {
  QStandardItemModel *householdModel = new QStandardItemModel (0, 2, parent);

  householdModel->setHeaderData (0, Qt::Horizontal, "Household");
  householdModel->setHeaderData (1, Qt::Horizontal, "Played this Rotation");

  return householdModel;
}

QStandardItemModel *createFamilyModel (QObject *parent)  {
  QStandardItemModel *familyModel = new QStandardItemModel (0, 2, parent);

  familyModel->setHeaderData (0, Qt::Horizontal, "Sim");
  familyModel->setHeaderData (1, Qt::Horizontal, "Relationship");

  return familyModel;
}

int main (int argc, char *argv[])  {
  srand (time (0));

  QTextStream terminal (stderr);
  terminal << "Hi there, stderr!" << endl;

  QApplication app (argc, argv);
  MainWindow mainWin;
  QStandardItemModel *simModel = createSimModel (&mainWin);
  QStandardItemModel *householdModel = createHouseholdModel (&mainWin);
  QStandardItemModel *familyModel = createFamilyModel (&mainWin);
  mainWin.setSimModel (simModel);
  mainWin.setHouseholdModel (householdModel);
  mainWin.setFamilyModel (familyModel);
  mainWin.show ();
  return app.exec ();
}
