#ifndef SETTINGSDIALOG_H
#define SETTINGSDIALOG_H

#include <QDialog>

class QSpinBox;
class QCheckBox;
class QComboBox;
class QPushButton;
class QVBoxLayout;
class QHBoxLayout;
class QGridLayout;
class QLineEdit;

class SettingsDialog : public QDialog  {
  Q_OBJECT

  public:
    SettingsDialog (int, bool, int, bool, int, bool, int, int, int, QString);

    QString getCSV ();
    void readCSV (QString, int);
    void readCSV0_4 (QString);
    void readCSV0_2 (QString);

  signals:
    void setRotation (int);
    void setAutoCollegeRotation (bool);
    void setCollegeRotation (int);
    void setAutoGoToCollege (bool);
    void setGoToCollegeTime (int);
    void setAutoBirthday (bool);
    void setAutoBirthdayTime (int);
    void setAgeDisplay (int);
    void setEPFlags (int);
    void setSimPELocation (QString);

  private slots:
    void updateEPFlags ();
    void browseForSimPE ();

  private:
    QSpinBox *rotationSpinBox;

    QCheckBox *collegeRotationCheckBox;
    QSpinBox *collegeRotationSpinBox;

    QCheckBox *autoGoToCollegeCheckBox;
    QSpinBox *autoGoToCollegeSpinBox;

    QCheckBox *autoBirthdayCheckBox;
    QComboBox *autoBirthdayComboBox;

    QComboBox *ageDisplayComboBox;

    QLineEdit *simPELocationEdit;
    QPushButton *findSimPEButton;

    QCheckBox *uniBox;
    QCheckBox *nightlifeBox;
    QCheckBox *ofbBox;
    QCheckBox *petsBox;
    QCheckBox *seasonsBox;
    QCheckBox *bvBox;
    QCheckBox *freetimeBox;
    QCheckBox *alBox;

    QPushButton *closeButton;

    QHBoxLayout *rotationLayout;
    QHBoxLayout *collegeRotationLayout;
    QHBoxLayout *autoGoToCollegeLayout;
    QHBoxLayout *autoBirthdayLayout;
    QHBoxLayout *ageDisplayLayout;
    QHBoxLayout *simPELocationLayout;
    QGridLayout *expansionPackLayout;

    QVBoxLayout *mainLayout;
};

#endif
