#include <QObject>
#include <QModelIndex>
#include <QString>
#include <QRegExp>
#include <QTextStream>
#include <QMessageBox>

#include <iostream>
using namespace std;

#include "const.h"
#include "simproxymodel.h"
#include "sim.h"

SimProxyModel::SimProxyModel (QObject *parent)
  : QSortFilterProxyModel (parent)
{}

void SimProxyModel::setSourceModel (QAbstractItemModel *model)  {
  this->QSortFilterProxyModel::setSourceModel (model);
}

bool SimProxyModel::lessThan (const QModelIndex &one, const QModelIndex &two)
  const {
  QTextStream terminal (stdout);
  QRegExp regExpOne ("^(\\d+) .+");
  QRegExp regExpTwo ("^(\\d+) .+");
  QString oneData = sourceModel ()->data (one).toString ();
  QString twoData = sourceModel ()->data (two).toString ();

  if (one.column () != 2 && one.column () != 3)
    return oneData < twoData;

  if (regExpOne.exactMatch (oneData) && regExpTwo.exactMatch (twoData))
    return regExpOne.cap(1).toInt () < regExpTwo.cap(1).toInt ();

  else if (oneData.contains ("Baby")) return true;
  else if (twoData.contains ("Baby")) return false;
  else if (oneData == "Puppy") return true;
  else if (twoData == "Puppy") return false;
  else if (oneData == "Kitten") return true;
  else if (twoData == "Kitten") return false;
  else if (oneData.contains ("Toddler")) return true;
  else if (twoData.contains ("Toddler")) return false;
  else if (oneData.contains ("Child")) return true;
  else if (twoData.contains ("Child")) return false;
  else if (oneData.contains ("Teen")) return true;
  else if (twoData.contains ("Teen")) return false;
  else if (oneData.contains ("Freshman")) return true;
  else if (twoData.contains ("Freshman")) return false;
  else if (oneData.contains ("Sophomore")) return true;
  else if (twoData.contains ("Sophomore")) return false;
  else if (oneData.contains ("Junior")) return true;
  else if (twoData.contains ("Junior")) return false;
  else if (oneData.contains ("Senior")) return true;
  else if (twoData.contains ("Senior")) return false;
  else if (oneData.contains ("Adult")) return true;
  else if (twoData.contains ("Adult")) return false;
  else if (oneData == "Servo") return true;
  else if (twoData == "Servo") return false;
  else if (oneData == "Large Dog") return true;
  else if (twoData == "Large Dog") return false;
  else if (oneData == "Small Dog") return true;
  else if (twoData == "Small Dog") return false;
  else if (oneData == "Cat") return true;
  else if (twoData == "Cat") return false;
  else if (oneData.contains ("Ghost")) return false;
  else if (twoData.contains ("Ghost")) return true;
  else if (oneData.contains ("Cat")) return false;
  else if (twoData.contains ("Cat")) return true;
  else if (oneData.contains ("Small Dog")) return false;
  else if (twoData.contains ("Small Dog")) return true;
  else if (oneData.contains ("Large Dog")) return false;
  else if (twoData.contains ("Large Dog")) return true;
  else if (oneData.contains ("Elder")) return true;
  else if (twoData.contains ("Elder")) return false;

  terminal << "All tests failed.  Resorting to default." << endl;

  return oneData < twoData;
}
