#ifndef UPDATEDIALOG_H
#define UPDATEDIALOG_H

#include <QDialog>
#include <QList>
#include <QPointer>

#include "sim.h"

class QString;
class QLabel;
class QStringList;
class QPushButton;
class QHBoxLayout;
class QVBoxLayout;
class UpdateEntry;

class UpdateDialog : public QDialog  {
  Q_OBJECT

  public:
    UpdateDialog ();

    void addText (QString);
    void addChoice (QStringList);
    void addSimChoice (QList< QPointer<Sim> >);
    void addNumberChoice (int, int);
    void addEdit ();
    void reset ();

  signals:
    void newEvent (UpdateEntry*);

  private slots:
    void setWarning (QString);
    void makeUpdate ();

  private:
    QHBoxLayout *makeSpace ();
    QString getAllText ();
    void sortList (QList< QPointer<Sim> >&);

    QList< QPointer<Sim> > firstSimList;
    QList< QPointer<Sim> > secondSimList;

    QLabel *warningLabel;

    QPushButton *addButton;
    QVBoxLayout *textLayout;
    QVBoxLayout *mainLayout;
};

#endif
