#ifndef UPDATEENTRY_H
#define UPDATEENTRY_H

#include <QWidget>
#include <QPointer>

#include "const.h"
#include "sim.h"

class Sim;
class QString;
class QLabel;
class QPushButton;
class QHBoxLayout;

class UpdateEntry : public QWidget  {
  Q_OBJECT

  public:
    UpdateEntry (QString, Sim*, Sim*);

    void go ();

    QString getText ();
    int getFirstSimNum (QList< QPointer<Sim> >);
    int getSecondSimNum (QList< QPointer<Sim> >);

  signals:
    void holdAllBut (Sim*, int);
    void holdHousehold (QString, int);
    void holdAllHouseholdsBut (QString, int);
    void newSim (QString, int, int, int, int, QString = "", int = NONE, 
                 Sim* = NULL, Sim* = NULL);
    void newTowniePair (QString, int, QString, int, int, int, Sim*);
    void removeSim (Sim*);
    void addToAchievementsPage (QString, Sim*, Sim*);
    void deleteMe (UpdateEntry*);

  private slots:
    void deleteMe ();

  private:
    int convertAspiration (QString);

    QLabel *display;
    QPushButton *deleteButton;
    QHBoxLayout *layout;

    QPointer<Sim> firstSim;
    QPointer<Sim> secondSim;
};

#endif
