#ifndef UPDATEPAGE_H
#define UPDATEPAGE_H

#include <QWidget>
#include <QList>
#include <QPointer>

#include "sim.h"

class QScrollArea;
class QPushButton;
class QComboBox;
class QLabel;
class QHBoxLayout;
class QVBoxLayout;
class UpdateEntry;
class UpdateDialog;

class UpdatePage : public QWidget  {
  Q_OBJECT

  public:
    UpdatePage (QList< QPointer<Sim> >);
    void setSimList (QList< QPointer<Sim> >);
    void updateEPFlags (int);
    void updateRotationLength (int);

    QString getCSV ();
    void readCSV (QString);
    void clear ();

  signals:
    void rotate ();

    void holdAllBut (Sim*, int);
    void holdHousehold (QString, int);
    void holdAllHouseholdsBut (QString, int);
    void newSim (QString, int, int, int, int, QString, int, Sim*, Sim*);
    void newTowniePair (QString, int, QString, int, int, int, Sim*);
    void removeSim (Sim*);
    void addToAchievementsPage (QString, Sim*, Sim*);

  public slots:
    void addEvent (UpdateEntry*);

  private slots:
    void setSpecificBox (const QString&);

    void createUpdateDialog ();
    void deleteEvent (UpdateEntry*);

    void doUpdate ();

  private:
    void setLivingSimsList ();

    QList< QPointer<Sim> > simList;
    QList< QPointer<Sim> > livingSims;
    int epFlags;
    int rotationLength;

    UpdateDialog *dialog;

    QScrollArea *scrollArea;
    QWidget *eventList;
    QVBoxLayout *eventLayout;
    
    QComboBox *catagoryBox;
    QComboBox *specificBox;
    QPushButton *addButton;
    QPushButton *updateButton;
    QHBoxLayout *comboBoxLayout;
    QVBoxLayout *mainLayout;
};

#endif
